#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include "apc.h"
#include "buffalo_funcs.h"

int write_out_status(int event){

//    TRACE(syslog(LOG_ALERT,"entered %s event=%d",__FUNCTION__,event));

	FILE *fp;
	char ups_buf[128];
	char temp_ups_buf[16];
	int eq_length;

	struct buf_state buf_status;
	
	buf_status.ups_status=UPS_STATUS_DEFAULT;
	buf_status.battery_low=UPS_BATTERY_DEFAULT;
	buf_status.shutdown_active=UPS_SHUTDOWN_DEFAULT;

	if(((fp=fopen(UPS_STATUS_FILE,"r"))==NULL) || (event == CMDFIRSTREPORT) || (event != CMDLOADLIMIT && event != CMDPOWEROUT && event != CMDMAINSBACK)){ //CMDFIRSTREPORTȂ�Aups_status�ݍ܂Ȃ
		
	}else{
		while((fgets(ups_buf,sizeof(ups_buf),fp))!=NULL){
			if(strstr(ups_buf,"ups_status=")!=NULL){
				eq_length=strcspn(ups_buf,"=");
				strcpy(temp_ups_buf,ups_buf+eq_length+1);
				buf_status.ups_status=atoi(temp_ups_buf);
			}else if(strstr(ups_buf,"battery_low=")!=NULL){
				eq_length=strcspn(ups_buf,"=");
				strcpy(temp_ups_buf,ups_buf+eq_length+1);
				buf_status.battery_low=atoi(temp_ups_buf);
			}else if(strstr(ups_buf,"shutdown_active=")!=NULL){
				eq_length=strcspn(ups_buf,"=");
				strcpy(temp_ups_buf,ups_buf+eq_length+1);
				if(strstr(temp_ups_buf,UPS_SHUTDOWN_ACTIVE_C)!=NULL){
					buf_status.shutdown_active=UPS_SHUTDOWN_ACTIVE;
				}else if(strstr(temp_ups_buf,UPS_SHUTDOWN_NORMAL_C)!=NULL){
					buf_status.shutdown_active=UPS_SHUTDOWN_NORMAL;
				}else{
					buf_status.shutdown_active=UPS_SHUTDOWN_DEFAULT;
				}
			}
		}
		fclose(fp);
	}

	switch(event){
	
	case CMDLOADLIMIT:
		buf_status.battery_low=UPS_BATTERY_LOW;
		break;
	case CMDPOWEROUT:
		buf_status.ups_status=UPS_LINE_FAIL;
		system(CMD_UPS_FAIL);
		break;
	case CMDMAINSBACK:
//        TRACE(syslog(LOG_ALERT," %s> CMDMAINSBACK selected",__FUNCTION__));
		buf_status.ups_status=UPS_LINE_NORMAL;
		buf_status.battery_low=UPS_BATTERY_NORMAL;
		system(CMD_UPS_RECOVER);
		break;
	default:
		break;
	}

//        TRACE(syslog(LOG_ALERT," %s> ups_status=%d",__FUNCTION__,buf_status.ups_status));
//        TRACE(syslog(LOG_ALERT," %s> battery_low=%d",__FUNCTION__,buf_status.battery_low));
//        TRACE(syslog(LOG_ALERT," %s> shutdown=%d",__FUNCTION__,buf_status.shutdown_active));

	if((fp=fopen(UPS_STATUS_FILE,"w"))==NULL){
//        TRACE(syslog(LOG_ALERT," %s> file open failed.",__FUNCTION__));
		return (-1);
	}else{
		
		fprintf(fp,"ups_status=%d\n",buf_status.ups_status);
		fprintf(fp,"battery_low=%d\n",buf_status.battery_low);
		if(buf_status.shutdown_active==UPS_SHUTDOWN_ACTIVE){
			fprintf(fp,"shutdown_active=active\n");
		}else if(buf_status.shutdown_active==UPS_SHUTDOWN_NORMAL){
			fprintf(fp,"shutdown_active=normal\n");
		}

		fclose(fp);
	}

	return 0;
}

static int IsUseUpsRecover(void){
	FILE *fp;
	char buf[128];
	int ret=0;
	
	fp=fopen(BUFFALO_UPS_CONFIG_FILE, "r");
	if(fp == NULL){
		TRACE(printf("%s> Cant open config\n", __FUNCTION__));
		return 0;
	}
	while(fgets(buf, sizeof(buf), fp) != NULL){
		if(strstr(buf, RECOVER_CONFIG_KEY) != NULL){
			if(strstr(buf,"=on") != NULL){
				TRACE(printf("%s> Recover flag = on\n", __FUNCTION__));
				ret = 1;
			}else{
				TRACE(printf("%s> Recover flag = off\n", __FUNCTION__));
				ret = 0;
			}
		}
	}

	fclose(fp);

	return ret;		
}

static int SetUpsRecoverFlagUsb(void){
	FILE *fp;
	fp = fopen(PROC_UPS_RECOVER, "w");
	if(fp <= 0){
		return -1;
	}
	fprintf(fp, KEY_UPS_RECOVER_APC_USB);
	fclose(fp);
	
	return 0;
}

static int VerifyUpsRecoverFlagUsb(void){
	FILE *fp;
	char buf[128];
	int ret = 0;
	
	fp=fopen(PROC_UPS_RECOVER, "r");
	if(fp <= 0 ){
		return -1;
	}
	fgets(buf, sizeof(buf),fp);
	fclose(fp);
	
	if(strstr(buf, KEY_UPS_RECOVER_APC_USB) != NULL){
		TRACE(printf("%s> Verify succeeded\n", __FUNCTION__));
		ret = 0;
	}else{
		TRACE(printf("%s> Verify failed\n", __FUNCTION__));
		ret = -1;
	}
	
	return ret;
}

int SetupUpsRecoverFlagAuto(void){
	ENTERED;
	int ret = 0;
	if(IsUseUpsRecover()){
		SetUpsRecoverFlagUsb();
		if(VerifyUpsRecoverFlagUsb() != 0){
			ret = -1;
		}
	}else{
		syslog(LOG_INFO, "No need to set ups recovery flag...");
		TRACE(printf("No need to set ups recovery flag..."));
		return -1;
	}
	if (ret == 0 ){
		syslog(LOG_INFO, "Set ups recovery flag success.\nSystem automatically boot up after linefail recovering.");
		TRACE(printf("Set ups recovery flag success.\nSystem automatically boot up after linefail recovering."));
	}else{
		syslog(LOG_INFO, "Set ups recovery flag failed...");
		TRACE(printf("Set ups recovery flag failed..."));
	}
	LEAVING(ret);
	return ret;
}

